class UtilisateursController < ApplicationController
  # GET /utilisateurs
  # GET /utilisateurs.xml
  def index
    @utilisateurs = Utilisateur.find(:all)

    respond_to do |format|
      format.html # index.rhtml
      format.xml  { render :xml => @utilisateurs.to_xml }
    end
  end

  # GET /utilisateurs/1
  # GET /utilisateurs/1.xml
  def show
    @utilisateur = Utilisateur.find(params[:id])

    respond_to do |format|
      format.html # show.rhtml
      format.xml  { render :xml => @utilisateur.to_xml }
    end
  end

  # GET /utilisateurs/new
  def new
    @utilisateur = Utilisateur.new
  end

  # GET /utilisateurs/1;edit
  def edit
    @utilisateur = Utilisateur.find(params[:id])
  end

  # POST /utilisateurs
  # POST /utilisateurs.xml
  def create
    @utilisateur = Utilisateur.new(params[:utilisateur])

    respond_to do |format|
      if @utilisateur.save
        flash[:notice] = 'Utilisateur was successfully created.'
        format.html { redirect_to utilisateur_url(@utilisateur) }
        format.xml  { head :created, :location => utilisateur_url(@utilisateur) }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @utilisateur.errors.to_xml }
      end
    end
  end

  # PUT /utilisateurs/1
  # PUT /utilisateurs/1.xml
  def update
    @utilisateur = Utilisateur.find(params[:id])

    respond_to do |format|
      if @utilisateur.update_attributes(params[:utilisateur])
        flash[:notice] = 'Utilisateur was successfully updated.'
        format.html { redirect_to utilisateur_url(@utilisateur) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @utilisateur.errors.to_xml }
      end
    end
  end

  # DELETE /utilisateurs/1
  # DELETE /utilisateurs/1.xml
  def destroy
    @utilisateur = Utilisateur.find(params[:id])
    @utilisateur.destroy

    respond_to do |format|
      format.html { redirect_to utilisateurs_url }
      format.xml  { head :ok }
    end
  end
end
