package com.gestionnaires;

import java.util.Vector;
import com.articles.Article;

public class GestionnairePanier
{
	Vector<Article> vArticles = null;
	boolean bEstPaye = false;
	
	public GestionnairePanier()
	{
		this.vArticles = new Vector<Article>();
	}
	
	public void ajouterAchat(Article art)
	{
		Article artPan = null;
		boolean bArtTrouve = false;

		if (art == null)
			return;
		
		//Vrifie si pas dj prsent
		for (int i=0; i<this.vArticles.size() && !bArtTrouve; i++)
			if (this.vArticles.get(i).getRef().equals(art.getRef()))
			{
				artPan = this.vArticles.get(i);
				bArtTrouve = true;
			}

		//Si trouv, incrmente
		if (bArtTrouve)
			artPan.setQuantite(artPan.getQuantite()+1);
		//sinon, ajoute et met  jour la quantiti
		else
		{
			art.setQuantite(1);
			this.vArticles.add(art);
		}
	}
	
	public void modifieAchat(String sRefArticle, int quantite)
	{
		for (int i=0; i<this.vArticles.size(); i++)
			if (this.vArticles.get(i).getRef().equals(sRefArticle))
				this.vArticles.get(i).setQuantite(quantite);
	}
	
	public void enleverAchat(String sRefArticle)
	{
		for (int i=0; i<this.vArticles.size(); i++)
			if (this.vArticles.get(i).getRef().equals(sRefArticle))
				this.vArticles.remove(i);
	}
	
	public Vector<Article> donneContenu()
	{
		return this.vArticles;
	}

	public boolean getEstPaye()
	{
		return this.bEstPaye;
	}

	public void setEstPaye(boolean bEstPaye)
	{
		this.bEstPaye = bEstPaye;
	}
	
	public double getPrixTotalPanier()
	{
		double prixTotal = 0;

		for (int i=0; i<this.vArticles.size(); i++)
			prixTotal += this.vArticles.get(i).getPrix() * this.vArticles.get(i).getQuantite();

		return prixTotal;
	}
}
