ActionController::Routing::Routes.draw do |map|
  map.resources :addresses

  map.resources :customers

  map.resources :suppliers # ajouté automatiquement par ""./script/generate scaffold_resource supplier name:string description:text code:string created_at:datetime updated_at:datetime has_many:products"" dans uen console

  map.resources :products #idem, et permet de dire qu'il y a une ressource nommée PRODUCTS

  map.resources :utilisateurs
  map.resource  :session, :controller => 'sessions'

  #BACK OFFICE
  map.resource :admin do |admin|
    admin.resources :products, :controller => 'admin/products', :name_prefix => 'admin_'
    admin.resources :suppliers, :controller => 'admin/suppliers', :name_prefix => 'admin_'
  end

  #FRONT OFFICE
  map.resources :products, :suppliers

  # The priority is based upon order of creation: first created -> highest priority.
  
  # Sample of regular route:
  # map.connect 'products/:id', :controller => 'catalog', :action => 'view'
  # Keep in mind you can assign values other than :controller and :action

  # Sample of named route:
  # map.purchase 'products/:id/purchase', :controller => 'catalog', :action => 'purchase'
  # This route can be invoked with purchase_url(:id => product.id)

  # You can have the root of your site routed by hooking up '' 
  # -- just remember to delete public/index.html.
  # map.connect '', :controller => "welcome"
  map.connect '', :controller => "products"

  # Allow downloading Web Service WSDL as a file with an extension
  # instead of a file named 'wsdl'
  #map.connect ':controller/service.wsdl', :action => 'wsdl'

  # Install the default route as the lowest priority.
  map.connect ':controller/:action/:id.:format'
  map.connect ':controller/:action/:id'
end
