package PackAdh;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Cette classe permet de grer des Adhrent.
 */
public class Adherent {
	
	private int numeroAdherent;
	private String nom;
	private String ville;
	private int anneeNaissance;
	static int c_montantCotisation = 45;
	private int cotisationVersee;
	
	/**
	 * Donne le nom de l'adhrent courant.
	 */
	public String getNom()
	{
		return this.nom;
	}

	/**
	 * Donne le numro de l'adhrent courant.
	 */
	public int numeroAdherent()
	{
		return this.numeroAdherent();
	}
	
	/**
	 * Donne l'ge de l'adhrent courant.
	 */
	public int getAge()
	{
		int annee;
		DateFormat format = new SimpleDateFormat("yyyy");
		annee = Integer.parseInt(format.format(new Date()));
		return annee - this.anneeNaissance;
	}
	
	/**
	 * Donne la cotisation qu'a vers l'adhrent courant."
	 */
	public int getCotisationVersee()
	{
		return this.cotisationVersee;
	}
	
	/**
	 * Informe par un boolan, du versement ou non du total de la cotisation par l'adhrent courant.
	 */
	public boolean aJour()
	{
		boolean resultat;
		resultat = false;
		if (cotisationVersee == c_montantCotisation)
		{
			resultat = true;
		}
		return resultat;
	}
	
	/**
	 * Permet l'ajout d'une cotisation d'une valeur spcifique, verse par l'adhrent courant.
	 */
	public boolean cotiser(int versement)
	{
		cotisationVersee += versement;
		return true;
	}
	
	/**
	 * Constructeur de la classe Adhrent.
	 */
	public Adherent(int numAdh, String nomAdh, String villeAdh, int anneeNaissAdh)
	{
		numeroAdherent = numAdh;
		nom = nomAdh;
		ville = villeAdh;
		anneeNaissance = anneeNaissAdh;
		cotisationVersee = 0;
	}
	
	/**
	 * Retourne l'tat de l'adhrent courant au niveau de son versement (s'il est  jour ou pas).
	 */
	public String etat()
	{
		String resultat = "pas  jour";
		
		if(aJour() == true)
		{
			resultat = "a jour";
		}
		
		return resultat;
		
	}
	
	/**
	 * Retourne l'ensemble des attributs de l'adhrent courant.
	 */
	public String toString()
	{
		String resultat;
		
		resultat = "NumeroAdhrant : " + this.numeroAdherent;
		resultat = resultat + "\nNom : " + this.nom;
		resultat = resultat + "\nVille : " + this.ville;
		resultat = resultat + "\nAnne de naissance : " + this.anneeNaissance;
		resultat = resultat + "\nCotisation : " + this.cotisationVersee;
		resultat = resultat + "\nEtat : " + this.etat();
		
		return resultat;
	}
	
	/**
	 * Mthode principale.
	 */
	public static void main(String[] args)
	{
		/*Adherent adh1 = new Adherent(1,"DUPONT","STRASBOURG",1985);
		System.out.println(adh1.toString());
		adh1.cotiser(45);
		System.out.println(adh1.toString());*/
	}
}
