import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.Vector;
import com.articles.Article;
import com.articles.ArticlePanier;
import com.gestionnaires.Erreur;
import com.gestionnaires.GestionnairePanier;

public class ListeArticles
        extends HttpServlet
{
    com.gestionnaires.GestionnaireArticles gestArts = null;
    
    private void traiteRequeteHttp(HttpServletRequest request, HttpServletResponse response)
    	throws ServletException, IOException
    {
    	String sAction;
    	String sInfoArtRef;
    	String sPageAffichage;
    	Vector<Article> vArts = new Vector<Article>();
    	Article tmpArt = null;

    	sAction = request.getParameter("action");
    	if (sAction.equals("info"))
    	{
    		sInfoArtRef = request.getParameter("artRef");

    		tmpArt = new Article();
    		tmpArt.setRef(sInfoArtRef);
    		
	        request.setAttribute("art", tmpArt);
	        sPageAffichage = "/infos.jsp";
    	}
    	else
    	{
        	for (int i=0; i<5; i++)
        	{
        		tmpArt = new Article();
        		tmpArt.setRef("refArt"+i);
        		tmpArt.setCateg("cat"+i);
        		tmpArt.setDescription("desc"+1);
        		vArts.add(tmpArt);
        	}

        	if (!vArts.isEmpty())
        	{
    	        request.setAttribute("articles", vArts);
    	        
    	        sPageAffichage = "/listeArticles.jsp";
        	}
        	else
        	{
        		Vector<Erreur> vErrs = new Vector<Erreur>();
        		vErrs.add(new Erreur("Articles non disponibles"));
    	        request.setAttribute("erreurs", vErrs);
	        
    	        sPageAffichage = "/erreurs.jsp";
    		}
    	}

        ServletContext ctx = getServletContext();
        RequestDispatcher rd = ctx.getRequestDispatcher(sPageAffichage);
        rd.forward(request,response);
    }
    
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        this.traiteRequeteHttp(request, response);
    }
    
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
    {
        this.traiteRequeteHttp(request, response);
    }
    
    public String getServletInfo() {
        return "Gestion du panier";
    }
}
